'	getFields.vbs by Keith Collison, kcollison@erols.com 
'	Copyright September 26, 2000
'	Grabs any INPUT tag names and creates ASP code to DIM and 
'	retrieve those variables for use in an ASP Page
'	
'	Feel free to make any changes, but please don't distribute 
'	without giving me credit.  I'd be a little miffed.


Sub Main
    Dim app
	dim ARYNames()
	DIM objReg
	DIM cMatch
	DIM strLeftName,strName
	DIM intTestBracket,intTestSpace,intChopRight,intLoop
	DIM strHeader, strMsgTxt,strDIMString
	DIM intXPos,intYPos
	Dim intOrigSelLen,intOrigSelStart

	intLoop = 0
	strHeader = "'	Form variable retrieval ==========================================" & vbcrlf
	strDIMString = "DIM "
    Set app = Application
	set objDoc = app.activedocument
	objDoc.getCaretPos  intXPos,intYPos
	
    HSYesNoCancel = 3
	hsYesNoCancel = 3
	hsCancel = 2
	hsYes = 6
	hsNo = 7
	
    Dim strText, intSelection
    intSelection = app.ActiveDocument.SelLength
    If intSelection > 0 Then
        strText = app.ActiveDocument.SelText
    Else
        strText = app.ActiveDocument.Text
    End If
	
	
	
	strMsgTxt = strMsgTxt & "Press:" & vbcrlf & "  'Yes' to use Request.Form," & vbcrlf & "  'No' to use Request.QueryString," & vbcrlf & "  'Cancel' to exit." & vbcrlf & vbcrlf
	strMsgTxt = strMsgTxt & "WARNING: This utility will over write anything you have in your clipboard." & vbcrlf
	strMsgTxt = strMsgTxt & "(Use Cancel if this is not desired)" & vbcrlf
	answer = app.MessageBox(strMsgTxt, "Form variables", HSYesNoCancel)
	' if user selected form, set strRequest to request.form
	if answer = hsYes then strRequest = " = Request.Form("""   
	' if user selected querystring, set strRequest to request.querystring
	if answer = hsNo then strRequest = " = Request.QueryString("""
	' if cancel, escape script
	if answer = hsCancel then exit sub
		' Set regular expression
		Set objReg = new RegExp
		strPattern = "<(select|input|textarea)+[^>]*name=[^>]*>"
		objReg.global = true
		objReg.ignorecase = true
		objReg.pattern = strPattern
		
		' Set up Matches collection 
		set cMatch = objReg.execute(strText)
		
		' if any matches were found fill up ARYNames with names found
		if cMatch.count > 0 THEN
			
				'For each match in the matches collection
				for each item in cMatch
					set objReg2 = new RegExp
					strPattern2 = "name=""*([^"">\s]*)"
					objReg2.pattern = strPattern2
					set match2 = objReg2.execute(item.value)
						for each dd in match2
							strName2 = objReg2.replace(dd.value,"$1")
						next
					if intLoop > 0 THEN
						if ARYNames(intLoop-1) <> strName2 THEN
							Redim PRESERVE ARYNames(intLoop)
							ARYNames(intLoop) = strName2
							intLoop = intLoop + 1
						END IF
					else
						redim ARYNames(intLoop)
						ARYNames(intLoop) = strName2
						intLoop = intLoop + 1
					END IF
				Next
	
				' Turn off screen updates, move to end of doc, create a blank line and get cursor position
				objDoc.BeginUpdate
				objDoc.CursorDocEnd(false)
				objDoc.inserttext vbcrlf,false
				objDoc.GetCaretPos intBeginXPos,intBeginYPos
					' Loop through collected names to compose output strings
					for intNames = 0 to UBOUND(ARYNames)
						strOutputRe = strOutputRe & ARYNames(intNames) & strRequest & ARYNames(intNames) & """)" & vbcrlf
						strDimString = strDimString & ARYNames(intNames) & ","
							' Don't want the DIM string too long.  After five on a line, make a carriage return
							if intNames MOD 5 = 0 AND intNames > 0 AND intNames <> UBOUND(ARYNames) THEN 
								strDimString = left(strDimString,len(strDimString)-1)
								strDimString = strDimString  & vbcrlf & "DIM "
							END IF
					next
					' Trim last comma of Dim string and follow it with some carriage returns
					strDimString = left(strDimString,len(strDimString)-1) & vbcrlf & vbcrlf
					' chop off last carriage return
					strOutputRe  = left(strOutputRe,len(strOutputRe)-2)
					' Insert the text, select it, and cut it to clipboard
					objDoc.InsertText strHeader & strDimString  & strOutputRe,false
					objDoc.CursorLineEnd(false)
					objDoc.GetCaretPos intEndXPos,intEndYPos
					objDoc.selectCurrentLine
						' Loop the cursor up command as many times as lines were written, selecting as we go
						for i = 1 to intEndYPos - intBeginYPos
							objDoc.CursorUp(true)
						next
					app.ExecCommand 37,0
					' Display message, endupdate, put cursor back where it was
					msgBox "The string initializing the variables is now in your clipboard." & vbcrlf & "Use 'Paste' to use on your page"
					objDoc.EndUpdate
					objDoc.SetCaretPos intXPos,intYPos
		' Else no matching text was found
		else
			msgBox "No matching fields found!"
			exit SUB
		END IF
	' clear variables and we're outta here
	set objReg = nothing
	set cMatch = nothing
	Set objDoc = nothing
    Set app = Nothing
End Sub